# -*- mode: python; coding: utf-8 -*-
# Pigment rendering library
#
# Copyright © 2006 Fluendo Embedded S.L. <www.fluendo.com>
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 2. See "LICENSE.GPL" in
# the root of this distribution including a special exception to use
# Pigment with Fluendo's plugins.
#
# The GPL part of Pigment is also available under a commercial licensing
# agreement from Fluendo. See "LICENSE.Pigment" in the root directory
# of this distribution package for details on that license.

"""
"""

from pgm.form import color, stroke, shape


class Rectangle(shape.Shape):
    """
    """

    def __init__(self, size=(50,50), position=(0,0), paint=None,
                 stroke=stroke.Stroke(), shadow=None, media=None):
        if paint == None:
            paint = color.Color()
        shape.Shape.__init__(self, size, position, paint, stroke, shadow, media)


class RoundRectangle(Rectangle):
    """
    """

    def __init__(self, size=(50,50), position=(0,0), paint=None,
                 stroke=stroke.Stroke(), shadow=None, media=None,
                 arc=(0,0)):
        Rectangle.__init__(self, size, position, paint, stroke, shadow, media)
        self.arc = arc

    # Property definitions

    def arc__get(self):
        """
        """
        return self._arc

    def arc__set(self, arc):
        """
        """
        self._arc = arc
        self._surface.set_arc(arc[0], arc[1])


# class Ellipse(Rectangle):
#     """
#     """

#     def __init__(self, size=(0,0), paint=color.Color(),
#                  stroke=stroke.Stroke(), shadow=None, media=None):
#         Rectangle.__init__(self, size=size, paint=paint,
#                            stroke=stroke, shadow=shadow, media=media)
