# -*- mode: python; coding: utf-8 -*-
# Pigment rendering library
#
# Copyright © 2006 Fluendo Embedded S.L. <www.fluendo.com>
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 2. See "LICENSE.GPL" in
# the root of this distribution including a special exception to use
# Pigment with Fluendo's plugins.
#
# The GPL part of Pigment is also available under a commercial licensing
# agreement from Fluendo. See "LICENSE.Pigment" in the root directory
# of this distribution package for details on that license.

"""
"""

from pgm.util import maths
from pgm.form import component, color

# Stroking types
CONTINUOUS, DASHED = 0, 1


class Stroke(component.Component):
    """
    """

    def __init__(self, width=0.0, color=color.Color(color.WHITE),
                 pattern=CONTINUOUS, factor=1):
	component.Component.__init__(self)
        self.width = width
        self.color = color
        self.pattern = pattern
        self.factor = factor

    # Property definitions

    def width__get(self):
        """The width"""
        return self._width

    def width__set(self, width):
        self._width = maths.clamp(width, 0.0, 10.0)
        for shape in self._shape:
            shape._surface.set_width(width)

    def color__get(self):
        """The color"""
        return self._color

    def color__set(self, color):
        self._color = color
        for shape in self._shape:
            shape._surface.set_stroke_color(color.r, color.g, color.b, color.a)

    def pattern__get(self):
        """The pattern"""
        return self._pattern

    def pattern__set(self, pattern):
        self._pattern = pattern
	for shape in self._shape:
	    shape._surface.set_pattern(pattern)

    def factor__get(self):
        """The factor of the pattern"""
        return self._factor

    def factor__set(self, factor):
        self._factor = factor
	for shape in self._shape:
	    shape._surface.set_factor(factor)
