# -*- mode: python; coding: utf-8 -*-
# Pigment rendering library
#
# Copyright © 2006 Fluendo Embedded S.L. <www.fluendo.com>
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 2. See "LICENSE.GPL" in
# the root of this distribution including a special exception to use
# Pigment with Fluendo's plugins.
#
# The GPL part of Pigment is also available under a commercial licensing
# agreement from Fluendo. See "LICENSE.Pigment" in the root directory
# of this distribution package for details on that license.

"""
"""

from pgm import widget
from pgm.layout import window


class Leaf(widget.Widget):
    """
    Base class, not meant to be instanciated.
    """

    def __init__(self, size, position):
        widget.Widget.__init__(self, size, position)
        self.align = (0.5, 0.5)

    # Property definitions

    def x_align__get(self):
        """The x alignment"""
        return self._x_align
    def x_align__set(self, x_align):
        self._x_align = x_align

    def y_align__get(self):
        """The y alignment"""
        return self._y_align
    def y_align__set(self, y_align):
        self._y_align = y_align

    def align__get(self):
        """The alignment"""
        return (self._x_align, self._y_align)
    def align__set(self, align):
        self._x_align, self._y_align = align

    # Property overriding

    # Public methods

    # Private methods

    def _do_motion_event(self, event):
        pass

    def _do_key_event(self, event):
        pass

    def _do_button_event(self, event):
        pass

    def _do_scroll_event(self, event):
        pass
