# -*- mode: python; coding: utf-8 -*-
# Pigment rendering library
#
# Copyright © 2006 Fluendo Embedded S.L. <www.fluendo.com>
# All rights reserved.
#
# This file is available under one of two license agreements.
#
# This file is licensed under the GPL version 2. See "LICENSE.GPL" in
# the root of this distribution including a special exception to use
# Pigment with Fluendo's plugins.
#
# The GPL part of Pigment is also available under a commercial licensing
# agreement from Fluendo. See "LICENSE.Pigment" in the root directory
# of this distribution package for details on that license.

"""
"""

from pgm import log
from pgm.util import classinit, maths


class KeyFrame(object):
    """
    """

    # Allows property fget/fset/fdel/doc overriding
    __metaclass__ = classinit.ClassInitMeta
    __classinit__ = classinit.build_properties

    def __init__(self, value=None, time=0.0):
        self.value = value
        self.time = time

    def __repr__(self):
        return "<keyframe.KeyFrame(%r, %.2f)>" % (self._value, self._time)

    # Property definitions

    def value__get(self):
        """The value"""
        return self._value

    def value__set(self, value):
        self._value = value

    def time__get(self):
        """The time in the range [0.0, 1.0]"""
        return self._time

    def time__set(self, time):
        self._time = maths.clamp(time, 0.0, 1.0)
